HDU1796(数论,容斥原理)

来源:互联网 发布:易语言编写软件 编辑:程序博客网 时间:2024/05/16 00:58
也是容斥原理的应用,这篇博客用了DFS,比较明晰。原文地址:
http://www.cnblogs.com/jackge/archive/2013/04/03/2997169.html

How many integers can you find

Time Limit: 12000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6745    Accepted Submission(s): 1957


Problem Description
  Now you get a number N, and a M-integers set, you should find out how many integers which are small than N, that they can divided exactly by any integers in the set. For example, N=12, and M-integer set is {2,3}, so there is another set {2,3,4,6,8,9,10}, all the integers of the set can be divided exactly by 2 or 3. As a result, you just output the number 7.
 

Input
  There are a lot of cases. For each case, the first line contains two integers N and M. The follow line contains the M integers, and all of them are different from each other. 0<N<2^31,0<M<=10, and the M integer are non-negative and won’t exceed 20.
 

Output
  For each case, output the number.
 

Sample Input
12 22 3
 

Sample Output
7
 

Author
wangye
 

Source
2008 “Insigma International Cup” Zhejiang Collegiate Programming Contest - Warm Up(4)
 



题目大意:给定n和一个大小为m的集合,集合元素为非负整数。为1...n内能被集合里任意一个数整除的数字个数。n<=2^31,m<=10



解题思路:容斥原理地简单应用。先找出1...n内能被集合中任意一个元素整除的个数,再减去能被集合中任意两个整除的个数,即能被它们两只的最小公倍数整除的个数,因为这部分被计算了两次,然后又加上三个时候的个数,然后又减去四个时候的倍数...所以深搜,最后判断下集合元素的个数为奇还是偶,奇加偶减。



#include <cmath>#include <cstring>#include <cstdio>#include <vector>#include <string>#include <algorithm>#include <string>#include <set>#include <iostream>using namespace std;#define MAXN 25#define LEN 1000000#define INF 1e9+7#define MODE 1000000typedef long long ll;ll n,cnt=0;ll ans=0;int m;int a[MAXN];int que[LEN];int gcd(int a,int b){    if(b==0)        return a;    else        return gcd(b,a%b);}void DFS(int cur,long long lcm,int id){    lcm=a[cur]/gcd(a[cur],lcm)*lcm;    if(id&1)        ans+=(n-1)/lcm;     //因为这题并不包含n本身,所以用n-1    else        ans-=(n-1)/lcm;    for(int i=cur+1;i<cnt;i++)        DFS(i,lcm,id+1);}int main(){    while(~scanf("%d%d",&n,&m)){        cnt=0;        int x;        while(m--){            scanf("%d",&x);            if(x!=0)                a[cnt++]=x;        }        ans=0;        for(int i=0;i<cnt;i++)            DFS(i,a[i],1);        cout<<ans<<endl;    }    return 0;}


0 0
原创粉丝点击